appModule.controller('intelligentDHomeController', ['$scope', '$sce', '$state', 'appService', '$timeout', '$ionicScrollDelegate', '$stateParams', '$window', function($scope, $sce, $state, appService, $timeout, $ionicScrollDelegate, $stateParams, $window) {
  /* data */
  $scope.productId = $stateParams.productId;
  $scope.stateName = $state.current.name;
  $scope.bannerArray;
  $scope.noticeArray;
  $scope.dynamicList;
  $scope.partyList;
  $scope.serviceArticleArray;
  $scope.domore;
  $scope.areaId;
  $scope.isSanziAdmin = true
  /*** 
   * life cycle 
   * */
  $scope.$on('$ionicView.beforeEnter', function() {
    // $scope.closeVideo = true
    // $scope.initStaticVideo()
    $scope.homePageBannerSwiper && $scope.initBannerSwiper();
    $scope.homePageNoticeSwiper && $scope.initNoticeSwiper();
    $scope.intelligentDPartyListSwiper && $scope.initPartySwiper();
  });
  $scope.$on('$ionicView.afterLeave', function() {
    $scope.homePageBannerSwiper && $scope.homePageBannerSwiper.destroy(true, true);
    $scope.homePageNoticeSwiper && $scope.homePageNoticeSwiper.destroy(true, true);
    $scope.intelligentDPartyListSwiper && $scope.intelligentDPartyListSwiper.destroy(true, true);
  });
  $scope.$on('changeRegion', function(e, district) {
    console.log(district)
    if ($scope.areaId != district.id) {
      $scope.district = district;
      $scope.init();
    }
    $scope.areaId = district.id;
    $scope.region = {
      id: district.id,
      name: district.name,
      regionCode: district.regionCode,
    }
    // $scope.isCv19 = ($scope.areaId == '151' || $scope.areaId == '153' || $scope.areaId == '155' || $scope.areaId == '2001');
    //151 建和 153鹏程 155后牧
  });
  $scope.initStaticVideo = function() {
    var showOnce
    var str = $window.localStorage.getItem("introVideoSc_static")
    var obj = JSON.parse(str)
    var areaId = obj && obj.areaId
    $scope.regionCode = $scope.regionCode || $stateParams.regionCode || $scope.publicCityId
    if ($scope.regionCode == areaId) {
      $scope.staticVideoPath = obj.path
    } else $scope.closeVideo = true
    var ls_showOnce = $window.localStorage.getItem("static_introVideo_showOnce");
    $scope.regionList = ls_showOnce && JSON.parse(ls_showOnce).regionList || []
    $scope.regionList.forEach(function(regionId) {
      if (regionId == $scope.regionCode) showOnce = true
    })
    // var showOnce = false //不展示视频
    if (showOnce) {
      $timeout(function() {
        $scope.initVideo()
      })
    } else
      $scope.closeVideo = false
  }
  $scope.bannerHeight = window.innerWidth ? {
    'height': (window.innerWidth - 20) * 0.5625 + 'px'
  } : false;
  window.onresize = function() {
    $scope.$apply(function() {
      $scope.bannerHeight = window.innerWidth
        ? {
          height: (window.innerWidth - 20) * 0.5625 + 'px',
        }
        : false;
    });
  };
  /***
   * method 
   * */
  /* $scope.goIntelligentDCV19 = function() {
    $scope.$emit('loginFirst', function() {
      $scope.goState('intelligentDCV19', { region: $scope.district })
    })
  } */

  $scope.initVideo = function() {
    var introVideoHoumu = $('#introVideoHoumu');
    introVideoHoumu.on('ended', function() {
      $scope.introVideoHoumuCloseFn()
    });
    introVideoHoumu.on('timeupdate', function() {
      var currentTime = Math.floor(introVideoHoumu[0].currentTime);
      if (currentTime == 0) {
        $scope.$apply(function() {
          $scope.videoOpened = true
        })
      }
      if (currentTime == 0) {
        if ($scope.showCloseBtn) return
        $scope.$apply(function() {
          $scope.showCloseBtn = true
        })
        // introVideoHoumuCloseBtn[0].style["opacity"] = 1
      }
    });
    var introVideoHoumuCloseBtn = $('#introVideoHoumuCloseBtn')
    introVideoHoumuCloseBtn.on('mouseup', function() {
      $scope.introVideoHoumuCloseFn()
    });
  }
  $scope.changeShowOnce = function(b) {
    $scope.showOnce = b
  }
  $scope.introVideoHoumuCloseFn = function() {
    if ($scope.closeVideo) return
    if ($scope.showOnce) {
      console.log('showOnce')
      $scope.regionList.push($scope.regionCode)
      var str = JSON.stringify({ regionList: $scope.regionList })
      $window.localStorage.setItem("static_introVideo_showOnce", str)
    }
    $scope.$apply(function() {
      $scope.videoOpened = false
      $scope.closeVideo = true
      /* $timeout(function() {
        $scope.closeVideo = true
      }) */
    })
  }
  $scope.queryBanner = function() {
    appService.getData(urlMap.intelligentDBannerNews, {
      'type': 2,
      'level': $scope.district.level,
      'villageId': $scope.district.id
    }, function(results) {
      results = results && results[0] && results[0].resultList;
      if (!results) return;
      $scope.bannerArray = results;
      $scope.initBannerSwiper();
      $timeout(function() {
        $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
        $ionicScrollDelegate.resize()
      })
    });
  }
  $scope.queryNotice = function() {
    $scope.noticeArray = [];
    appService.getData(urlMap.intelligentDBannerNews, {
      'type': 1,
      'level': $scope.district.level,
      'villageId': $scope.district.id
    }, function(results) {
      results = results && results[0] && results[0].resultList;
      // console.log('通知', results);
      if (!results) return;
      $scope.noticeArray = results;
      $scope.initNoticeSwiper();
      $timeout(function() {
        $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
        $ionicScrollDelegate.resize()
      })
    });
  }
  $scope.initBannerSwiper = function() {
    $scope.homePageBannerSwiper && $scope.homePageBannerSwiper.destroy(true, true);
    if (!!$scope.bannerArray && $scope.bannerArray.length > 0) {
      $timeout(function() {
        $scope.homePageBannerSwiper = new Swiper('#intelligentDHomePageBannerSwiper', {
          width: undefined,
          autoplay: {
            disableOnInteraction: false,
          },
          effect: 'coverflow',
          slidesPerView: 1.2,
          centeredSlides: true,
          coverflowEffect: {
            rotate: 10,
            stretch: -16,
            depth: 50,
            modifier: 1,
            slideShadows: true
          },
          loop: true,
          /* pagination: {
            el: '.banner-swiper-pagination'
          }, */
          on: {
            tap: function(e) {
              var _e = e || event;
              $scope.getBannerArticleDetail(_e.target.getAttribute('itemid'));
            }
          }
        });
      });
    }
  }
  $scope.initNoticeSwiper = function() {
    $scope.homePageNoticeSwiper && $scope.homePageNoticeSwiper.destroy(true, true);
    if (!!$scope.noticeArray && $scope.noticeArray.length > 0) {
      $timeout(function() {
        $scope.homePageNoticeSwiper = new Swiper('#intelligentDHomePageNoticeSwiper', {
          direction: 'vertical',
          loop: true,
          autoplay: {
            delay: 3000,
            stopOnLastSlide: false,
            disableOnInteraction: false,
          },
          on: {
            tap: function(e) {
              var _e = e || event;
              $scope.getBannerArticleDetail(_e.target.getAttribute('itemid'))
            }
          },
        });
      });
    }
  }
  // 动态 155是 idivHoumuDongtai
  $scope.queryDynamicList = function() {
    var data = {
      level: $scope.district.level,
      districtId: $scope.district.id,
      rootMenu: 2,//1介绍, 2动态, 3党建, 4服务
      page: 1
    }
    var url = urlMap.intelligentDArticlesForHomeModule
    if ($scope.district.id == '155') {
      data = {
        villageId: 155
      }
      url = urlMap.idivHoumuDongtai
    }
    appService.getData(url, data,
      function(results) {
        // console.log('动态:', results.resultList);
        var list = results.resultList || results.data,
          length = list.length,
          articles = [];
        if (length > 0) {
          for (var i = 0; i < length && i < 8; i++) {
            var item = list[i],
              article = {};
            article.id = item.id;
            article.title = item.title; //标题
            article.picName = item.picName || $scope.pic + urlMap.defaultUpload; //缩略图
            articles.push(article);
          }
        }
        $scope.dynamicList = articles;
        $timeout(function() {
          $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
          $ionicScrollDelegate.resize()
        })
      });
  }
  // 党建 155是 idivHoumuDangjian
  $scope.queryPartyList = function() {
    var data = {
      level: $scope.district.level,
      districtId: $scope.district.id,
      rootMenu: 3,//1介绍, 2动态, 3党建, 4服务
      page: 1
    }
    var url = urlMap.intelligentDArticlesForHomeModule
    if ($scope.district.id == '155') {
      data = {
        villageId: 155
      }
      url = urlMap.idivHoumuDangjian
    }
    appService.getData(url, data,
      function(results) {
        // console.log('党建:', results.resultList);
        var list = results.resultList || results.data,
          length = list.length,
          articles = [];
        if (length > 0) {
          for (var i = 0; i < length; i++) {
            var item = list[i],
              article = {};
            article.id = item.id;
            article.title = item.title; //标题
            article.picName = item.picName || $scope.pic + urlMap.defaultUpload; //缩略图
            articles.push(article);
          }
        }
        $scope.partyList = articles;
        $scope.initPartySwiper();
        $timeout(function() {
          $timeout(function() {
            $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
            $ionicScrollDelegate.resize()
          })
        }, 100)
      });
  }
  $scope.initPartySwiper = function() {
    $scope.intelligentDPartyListSwiper && $scope.intelligentDPartyListSwiper.destroy(true, true);
    if (!!$scope.partyList) {
      $timeout(function() {
        $scope.intelligentDPartyListSwiper = new Swiper('#intelligentDPartyListSwiper', {
          slidesPerView: 'auto',
          slidesPerGroup: 3,
          resistanceRatio: 0
        })
      });
    }
  }
  $scope.queryServiceArticleArray = function(page) {
    if (page == 0 || page == 1) { //页面刷新时为0,下拉刷新时为1
      $scope.pageNext = 1;
      page = 1;
    }
    // $scope.$emit('loading', 'show');
    var data = {
      level: $scope.district.level,
      districtId: $scope.district.id,
      rootMenu: 4,//1介绍, 2动态, 3党建, 4服务
      page: page
    }
    appService.getData(urlMap.intelligentDArticlesForHomeModule, data,
      function(results) {
        $scope.$emit('loading', 'hide');
        // $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
        console.log(page, '服务:', results.resultList);
        if (page == 1) {
          $scope.serviceArticleArray = null;
        }
        var list = results.resultList,
          length = list.length,
          size = results.size,
          articles = $scope.serviceArticleArray || [];
        if (length < size) $scope.domore = false;
        else {
          $timeout(function() {
            $scope.domore = true
          }, 200)
        }
        if (length > 0) {
          for (var i = 0; i < length; i++) {
            var item = list[i],
              article = {},
              _summary;
            article.id = item.id;
            article.title = item.title; //标题
            article.picName = item.picName || $scope.pic + urlMap.defaultUpload; //缩略图
            article.createTime = item.createTime; //时间
            article.subMenuName = item.subMenuName;
            article.submenuid = item.submenuid;
            article.summary = $('<div>' + item.textcontent + '</div>').text().replace(/\s+/g, '');
            articles.push(article);
          }
        }
        $scope.serviceArticleArray = articles;
        $timeout(function() {
          $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
          $ionicScrollDelegate.resize()
        })
      });
  }
  $scope.init = function() {
    $scope.loadM = 3
    $scope.domore = true
    $scope.queryBanner();
    $scope.queryNotice();
    $scope.dynamicList =
      $scope.partyList =
      $scope.serviceArticleArray = null
    // $scope.queryDynamicList();
    // $scope.queryPartyList(0);
    // $scope.queryServiceArticleArray(0);
    // $scope.getAds(); // 获取广告信息
    $ionicScrollDelegate.scrollTop();
  }
  $scope.onInfinite = function() {
    console.log($scope.loadM)
    switch ($scope.loadM) {
      case 3:
        $scope.queryDynamicList();
        $scope.loadM++
        break;
      case 4:
        $scope.queryPartyList(0);
        $scope.loadM++
        break;
      case 5:
        $scope.queryServiceArticleArray(0);
        $scope.loadM++
        break;
      case 6:
        $scope.queryServiceArticleArray(++$scope.pageNext);
        break;
    }
  }
  $scope.getBannerArticleDetail = function(id) {
    $state.go('intelligentDArticleDetail', { id: id, shareFlag: 14, queryUrl: 'intelligentDBannerNewsDetail' })
  }
  $scope.getArticleDetail = function(id) {
    $state.go('intelligentDArticleDetail', { id: id, shareFlag: 13, queryUrl: 'intelligentDArticlesDetail' })
  }
  $scope.goDispatch = function() {
    $scope.$emit('realIdFirst', { formContent: true, editItem: 'idCard', region: $scope.region }, function() {
      $scope.goState('intelligentDDispatch', { district: $scope.district })
    })
  }
  $scope.goSanzi = function() {
    $scope.goState('jiweiSanzi', { region: $scope.region })
  }
}
]);
