appModule.controller('submitMsgController', ['$rootScope', '$scope', '$ionicPopup', 'appService', '$timeout', '$state', '$sce', '$ionicScrollDelegate',
  function($rootScope, $scope, $ionicPopup, appService, $timeout, $state, $sce, $ionicScrollDelegate) {
    $scope.stateName = $state.current.name;
    $scope.httpPath = '/msg/'
    $scope.filetype;
    $scope.maxWidth = 900;
    $scope.uploadedNum = 0;
    $scope.submiting
    $scope.imgfile = []; //img
    $scope.viofile = []; //vio
    $scope.init = function() {
      $scope.form = {
        content: '',
      };
      $scope.removeFile()
    }
    $scope.$on('$ionicView.loaded', function() {
      $scope.init()
    });
    $scope.$on('$ionicView.beforeLeave', function() {
      $rootScope.viewGoback = $rootScopeViewGoback
    });
    $scope.submit = function() {
      $scope.$emit('loginFirst', function() {
        if ($scope.submiting) return
        if (!$scope.form.content.trim()) {
          $scope.alert("请填写内容");
          return;
        }
        if ($scope.form.content.length > 1100) {
          $scope.alert("内容不能超过1000字！");
          return;
        }
        $ionicPopup.confirm({
          template: '您是否要提交当前内容?',
          cancelText: '取消',
          okText: '确认并提交'
        }).then(function(res) {
          if (res) {
            $scope.submiting = true;
            var noUpload
            $scope.imgfile.forEach(function(item) {
              if (!item.uploaded) noUpload = true
            })
            $scope.viofile.forEach(function(item) {
              if (!item.uploaded) noUpload = true
            })
            if (noUpload) return
            /* 没有附件 */
            $scope.postForm();
            return
          } else {
            $scope.submiting = false;
            console.log('返回！');
          }
        });
      });
    }
    $scope.fileChangeEvent = function() {
      var files = $('#localPhotoFile')[0].files;
      for (var i = 0; i < files.length; i++) {
        $scope.fileType = $scope.thisfileType(files[i].name);
        if ($scope.fileType == 'error') {
          $scope.alert('上传文件格式有误')
          return;
        }
        if (files[i].size > 100 * 1024 * 1024) {
          $scope.alert('文件体积过大, 最大为100M')
          return;
        }
        if ($scope.fileType == 1 && $scope.imgfile.length > 2) {
          $scope.alert('最多上传3张图片')
          return
        }
        if ($scope.fileType == 2 && $scope.viofile.length > 0) {
          $scope.alert('最多上传1段视频')
          return
        }
        try {
          readerfile(files[i]).then(function(e) {
            $scope.$apply(function() {
              if ($scope.fileType == 2) {
                $scope.viofile.push({
                  local64: $sce.trustAsResourceUrl(e),
                  uploaded: false
                })
                $scope.preUpload(0).then(function(res) {
                  $scope.$apply(function() {
                    $scope.viofile[res[1]].remotePath = res[0]
                    $scope.viofile[res[1]].remoteSrc = $scope.evalRemotePath(res[0], $scope.vio)
                    $scope.viofile[res[1]].uploaded = true
                  })
                  var noUpload
                  $scope.imgfile.forEach(function(item) {
                    if (!item.uploaded) noUpload = true
                  })
                  $scope.viofile.forEach(function(item) {
                    if (!item.uploaded) noUpload = true
                  })
                  if (!noUpload && $scope.submiting) $scope.postForm()
                })
              }
              else {
                // $scope.showimgfile.push(e)
                $scope.imgfile.push({
                  local64: e,
                  uploaded: false
                })
                // $scope.imgsSwipe && $scope.imgsSwipe.destroy(true, true);
                $timeout(function() {
                  !$scope.imgsSwipe && ($scope.imgsSwipe = new Swiper('#articleImgs', { //图片轮播 
                    zoom: {
                      toggle: false,
                    },
                    pagination: {
                      el: '.swiper-pagination',
                      dynamicBullets: true
                    },
                  }))
                })
                $scope.preUpload($scope.imgfile.length - 1).then(function(res) {
                  $scope.$apply(function() {
                    $scope.imgfile[res[1]].remotePath = res[0]
                    $scope.imgfile[res[1]].remoteSrc = $scope.evalRemotePath(res[0])
                    $scope.imgfile[res[1]].uploaded = true
                  })
                  var noUpload
                  $scope.imgfile.forEach(function(item) {
                    if (!item.uploaded) noUpload = true
                  })
                  $scope.viofile.forEach(function(item) {
                    if (!item.uploaded) noUpload = true
                  })
                  if (!noUpload && $scope.submiting) $scope.postForm()
                })
              }
            })
          })
        } catch (e) {
          alert(e);
          $scope.$apply(function() {
            $scope.showUploadNames.push(files);
          })
        }
      }
    }
    $scope.postForm = function() {
      // $scope.$emit('loginFirst', function() {
      $scope.$emit('loading', 'show');
      var imgList = []
      var vioList = []
      $scope.imgfile.forEach(function(item) {
        imgList.push(item.remotePath)
      });
      $scope.form.imgList = imgList.toString()
      $scope.viofile.forEach(function(item) {
        vioList.push(item.remotePath)
      });
      $scope.form.vioList = vioList.toString()
      $scope.form.userId = $scope.user.id;
      $scope.form.userName = $scope.user.userName;
      $scope.form.areaID = $scope.publicCityId;
      $scope.form.leaveMessage = $scope.form.content;
      var opts = {
        method: 'post',
        url: urlMap.insertMessage,
        params: $scope.form,
      };
      appService.queryData(opts, function(results) {
        $scope.$emit('loading', 'hide');
        $scope.submiting = false;
        $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
        $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
        console.log(results[0]);
        if (results[0] == 1) {
          $scope.msgInput = '';
          var msg = { t: '提示框', c: '留言成功!' };
          if (!!results[1]) {
            msg.t = '留言成功！';
            msg.c = results[1];
          }
          $scope.alert(msg.c, true, msg.t, '该留言审核中，请您耐心等待');
          $scope.init()
        }
      }, function() {
        $scope.submiting = false;
      }, function() {
        $scope.submiting = false;
      });
      // });
    };
    $scope.removeFile = function(reset) {
      // $scope.ufiles = []; //预览
      $scope.imgfile = []; //img
      // $scope.showimgfile = []; //img预览
      $scope.viofile = []; //vio
      $scope.showUploadNames = []; //预览失败 显示文件名
      if (!reset) {
        $('#localPhotoFile').val(''); //本地
        $scope.cameraFile = null; //拍摄
      }
    }
    $scope.remove = function(index, type) {
      if (type == 'img') {
        $scope.imgfile.splice(index, 1)
      }
    }
    /* 本地附件读取 */
    function readerfile(file) {
      return new Promise(function(resolve, reject) {
        var reader = new FileReader();
        reader.onload = function() {
          resolve(reader.result);
        };
        if (file) {
          reader.readAsDataURL(file)
        }
      })
    }
    /* 本地文件上传 */
    $scope.preUpload = function(index) {
      return new Promise(function(resolve, reject) {
        $timeout(function() {
          var file = document.getElementById('localPhotoFile').files[0]
          if (!file) {
            $scope.alert('附件上传有误')
          }
          var formData = new FormData();
          formData.append('httpPath', $scope.httpPath);
          formData.append('type', $scope.fileType);
          formData.append('maxWidth', $scope.maxWidth);
          formData.append('file', file);
          $.ajax({
            type: "POST",
            url: urlMap.fileUpload,
            data: formData,
            cache: false,
            processData: false,
            contentType: false,
          }).success(function(res) {
            console.log(res)
            var msg = res.msg
            var imgUrl = res.imgUrl || res.vioUrl;
            if (imgUrl) {
              resolve([imgUrl, index])
            } else {
              $scope.alert("文件上传失败，请联系客服人员！");
            }
          }).error(function(err) {
            $scope.$emit('loading', 'hide');
            $scope.alert("媒体上传失败，请联系客服人员！");
            reject()
          });
        })
      });
    }
    /* 拍摄上传 */
    $scope.preUploadCamera = function(index) {
      return new Promise(function(resolve, reject) {
        var file = $scope.cameraFile;
        var params = {};
        params.httpPath = $scope.httpPath;
        params.type = $scope.fileType;
        params.maxWidth = $scope.maxWidth;
        var ft = new FileTransfer();
        var options = new FileUploadOptions();
        options.fileKey = "file";
        options.mimeType = "multipart/form-data";
        options.fileName = file.name;
        options.params = params;
        //传输进度  
        ft.onprogress = function(progressEvent) {
        };
        ft.upload(file.fullPath, urlMap.fileUpload,
          function(res) {
            $scope.$emit('loading', 'hide');
            if (res.response) res = JSON.parse(res.response)
            var imgUrl = res.imgUrl || res.vioUrl;
            if (imgUrl) {
              resolve([imgUrl, index])
            } else {
              $scope.alert("文件上传失败，请联系客服人员！");
            }
          },
          function() {
            $scope.alert("媒体上传失败，请联系客服人员！");
          },
          options);
      })
    }
    /***
     * use camera
     */
    $scope.useCamera = function(type) {
      //开始录像(最长录制时间:60秒)
      if (type == 1) navigator.device.capture.captureImage(success, onError, { limit: 1 });
      if (type == 2) navigator.device.capture.captureVideo(success, onError);
      function success(mediaFiles) {
        for (var i = 0; i < mediaFiles.length; i++) {
          var name = mediaFiles[i].name;
          var path = mediaFiles[i].fullPath;
          $scope.fileType = $scope.thisfileType(name);
          if ($scope.fileType == 'error') {
            $scope.alert('上传文件格式有误')
            return;
          }
          if (mediaFiles[i].size > 100 * 1024 * 1024) {
            $scope.alert('文件体积过大, 最大为100M')
            return;
          }
          if ($scope.fileType == 1 && $scope.imgfile.length > 2) {
            $scope.alert('最多上传3张图片')
            return
          }
          if ($scope.fileType == 2 && $scope.viofile.length > 0 && !$scope.cameraFile) {
            $scope.alert('最多上传1段视频')
            return
          }
          $scope.$apply(function() {
            $scope.cameraFile = mediaFiles[i];
            if ($scope.fileType == 2) {
              $scope.viofile.push({
                local64: $sce.trustAsResourceUrl(path),
                uploaded: false
              })
              $scope.preUploadCamera(0).then(function(res) {
                $scope.$apply(function() {
                  $scope.viofile[res[1]].remotePath = res[0]
                  $scope.viofile[res[1]].remoteSrc = $scope.evalRemotePath(res[0], $scope.vio)
                  $scope.viofile[res[1]].uploaded = true
                })
                var noUpload
                $scope.imgfile.forEach(function(item) {
                  if (!item.uploaded) noUpload = true
                })
                $scope.viofile.forEach(function(item) {
                  if (!item.uploaded) noUpload = true
                })
                if (!noUpload && $scope.submiting) $scope.submit()
              })
            }
            else {
              $scope.imgfile.push({
                local64: path,
                uploaded: false
              })
              $timeout(function() {
                $scope.imgsSwipe && $scope.imgsSwipe.destroy(true, true);
                $scope.imgsSwipe = new Swiper('#articleImgs', { //图片轮播 
                  zoom: {
                    toggle: false,
                  },
                  pagination: {
                    el: '.swiper-pagination',
                    dynamicBullets: true
                  },
                });
              })
              $scope.preUploadCamera($scope.imgfile.length - 1).then(function(res) {
                $scope.$apply(function() {
                  $scope.imgfile[res[1]].remotePath = res[0]
                  $scope.imgfile[res[1]].remoteSrc = $scope.evalRemotePath(res[0])
                  $scope.imgfile[res[1]].uploaded = true
                })
              })
            }
          })
        }
      }
      //录制失败
      function onError(error) {
        // $scope.alert('未进行拍摄！错误码:' + error.code);
      }
    }
    $scope.showBigImage = function(i) {
      $scope.showImgSwiper = true
      $scope.imgsSwipe.updateSlides();
      $scope.imgsSwipe.slideTo(i, 0, false);
      $('#articleImgs').show();
      if (!$scope.isUpdateSize) { $scope.imgsSwipe.update(); $scope.isUpdateSize = true; }
      console.log(i)
    };
    $scope.hideBigImage = function() {
      $scope.showImgSwiper = false
      $scope.imgsSwipe.zoom.out();
      $('#articleImgs').hide();
    };

    /* $scope.$on('backButtonOn', function(e, data) {
      console.log('backButtonOn')
      if(!$scope.showImgSwiper)
    }); */
    $rootScopeViewGoback = $rootScope.viewGoback;
    $rootScope.viewGoback = function() {
      if ($scope.showImgSwiper) $scope.hideBigImage()
      else $rootScopeViewGoback()
    }
    $scope.vioFocus = function() {
      $('video').focus()
    }
    $scope.alert = function(info, back, title, subTitle) {
      $ionicPopup
        .alert({
          title: title || '提示框',
          subTitle: subTitle,
          template: info,
          buttons: [{ text: '知道了', type: 'button-positive' }],
        })
        .then(function(res) {
          if (back) $scope.viewGoback()
        });
    };
  },
]);
